source: installer/opengnsys_installer.sh @ e371a87

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacion
Last change on this file since e371a87 was 2e1b900, checked in by Ramón M. Gómez <ramongomez@…>, 6 years ago

#914: Installed/Update? newest ogLive version.

  • Property mode set to 100755
File size: 59.0 KB
RevLine 
[a01156a]1#!/bin/bash
2
3#####################################################################
[5f21d34]4####### Script instalador OpenGnsys
5####### Autor: Luis Guillén <lguillen@unizar.es>
[a01156a]6#####################################################################
7
8
[8ca0cc9]9#####################################################################
10####### Funciones de configuración
11#####################################################################
[9672640]12
[8ca0cc9]13# Devuelve en la variable PASSWORD la clave introducida por el usuario (o la indicada por defecto)
14function enterPassword ()
15{
16        local PASSWORD2
17        local DEFAULT_PASSWORD="$1"
18
19        while : ; do
20                stty -echo
21                read -r PASSWORD
22                stty echo
23                if [ -z "$PASSWORD" ]; then
24                        # Si esta vacio ponemos el valor por defecto
25                        PASSWORD="${PASSWORD:-$DEFAULT_PASSWORD}"
26                        break
27                else
28                        if [ -n "${PASSWORD//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
29                                echo -e "\\aERROR: Password must be alphanumeric, try again..."
30                        else
31                                echo -n -e "\\nConfirm password: "
32                                stty -echo
33                                read -r PASSWORD2
34                                stty echo
35                                if [ "$PASSWORD" == "$PASSWORD2" ]; then
36                                        break
37                                else
38                                        echo -e "\\aERROR: Passwords don't match, try again."
39                                fi
40                        fi
41                fi
42                echo -n -e "Please, enter a new password (${DEFAULT_PASSWORD}): "
43        done
44}
[9672640]45
[8ca0cc9]46# Recoge los datos de configuración introducidos por el usuario.
47function userData ()
48{
49        ####  AVISO: Puede editar configuración de acceso por defecto.
50        ####  WARNING: Edit default access configuration if you wish.
51        DEFAULT_MYSQL_ROOT_PASSWORD="passwordroot"      # Clave por defecto root de MySQL
52        DEFAULT_OPENGNSYS_DB_USER="usuog"               # Usuario por defecto de acceso a la base de datos
53        DEFAULT_OPENGNSYS_DB_PASSWD="passusuog"         # Clave por defecto de acceso a la base de datos
54        DEFAULT_OPENGNSYS_CLIENT_PASSWD="og"            # Clave por defecto de acceso del cliente       
[2e1b900]55        DEFAULT_OGLIVE="ogLive-bionic-5.0.0-27-generic-amd64-r20190830.7208cc9.iso"     # Cliente ogLive
[8ca0cc9]56
57        echo -e "\\nOpenGnsys Installation"
58        echo "=============================="
59
[5c82233]60        if [[ $- =~ s ]]; then
61                echo -e "\\nNot interactive mode: setting default configuration values.\\n"
62                MYSQL_ROOT_PASSWORD="$DEFAULT_MYSQL_ROOT_PASSWORD"
63                OPENGNSYS_DB_USER="$DEFAULT_OPENGNSYS_DB_USER"
64                OPENGNSYS_DB_PASSWD="$DEFAULT_OPENGNSYS_DB_PASSWD"
65                OPENGNSYS_CLIENT_PASSWD="$DEFAULT_OPENGNSYS_CLIENT_PASSWD"
66                OGLIVE="$DEFAULT_OGLIVE"
67                return
68        fi
69
[8ca0cc9]70        # Clave root de MySQL
71        echo -n -e "\\nEnter root password for MySQL (${DEFAULT_MYSQL_ROOT_PASSWORD}): "
72        enterPassword "$DEFAULT_MYSQL_ROOT_PASSWORD"
73        MYSQL_ROOT_PASSWORD="$PASSWORD"
74
75        # Usuario de acceso a la base de datos
76        while : ; do
77                echo -n -e "\\n\\nEnter username for OpenGnsys console (${DEFAULT_OPENGNSYS_DB_USER}): "
78                read -r OPENGNSYS_DB_USER
79                if [ -n "${OPENGNSYS_DB_USER//[a-zA-Z0-9]/}" ]; then # Comprobamos que sea un valor alfanumerico
80                        echo -e "\\aERROR: Must be alphanumeric, try again..."
81                else
82                        # Si esta vacio ponemos el valor por defecto
83                        OPENGNSYS_DB_USER="${OPENGNSYS_DB_USER:-$DEFAULT_OPENGNSYS_DB_USER}"
84                        break
85                fi
86        done
[9672640]87
[8ca0cc9]88        # Clave de acceso a la base de datos
[5f21d34]89        echo -n -e "\\nEnter password for OpenGnsys console (${DEFAULT_OPENGNSYS_DB_PASSWD}): "
[8ca0cc9]90        enterPassword "$DEFAULT_OPENGNSYS_DB_PASSWD"
91        OPENGNSYS_DB_PASSWD="$PASSWORD"
92
93        # Clave de acceso del cliente
94        echo -n -e "\\n\\nEnter root password for OpenGnsys client (${DEFAULT_OPENGNSYS_CLIENT_PASSWD}): "
95        enterPassword "$DEFAULT_OPENGNSYS_CLIENT_PASSWD"
96        OPENGNSYS_CLIENT_PASSWD="$PASSWORD"
97        unset PASSWORD
98
99        # Selección de clientes ogLive para descargar.
100        while : ; do
101                echo -e "\\n\\nChoose ogLive client to install."
102                echo -e "1) Kernel 5.0, 64-bit, EFI-compatible"
103                echo -e "2) Kernel 3.2, 32-bit"
104                echo -e "3) Both"
105                echo -n -e "Please, type a valid number (1): "
106                read -r OPT
107                case "$OPT" in
[9345a1f]108                        1|"")   OGLIVE="$DEFAULT_OGLIVE"
[8ca0cc9]109                                break ;;
110                        2)      OGLIVE="ogLive-precise-3.2.0-23-generic-r5159.iso"
111                                break ;;
[9345a1f]112                        3)      OGLIVE=" $DEFAULT_OGLIVE ogLive-precise-3.2.0-23-generic-r5159.iso";
[8ca0cc9]113                                break ;;
114                        *)      echo -e "\\aERROR: unknown option, try again."
115                esac
116        done
[3aaf91d]117
[8ca0cc9]118        echo -e "\\n=============================="
119}
[a01156a]120
[8ca0cc9]121# Asigna valores globales de configuración para el script.
122function globalSetup ()
123{
124        PROGRAMDIR=$(readlink -e "$(dirname "$0")")
125        PROGRAMNAME=$(basename "$0")
126
127        # Comprobar si se ha descargado el paquete comprimido (REMOTE=0) o sólo el instalador (REMOTE=1).
128        OPENGNSYS_SERVER="opengnsys.es"
129        DOWNLOADURL="https://$OPENGNSYS_SERVER/trac/downloads"
130        if [ -d "$PROGRAMDIR/../installer" ]; then
131                REMOTE=0
132        else
133                REMOTE=1
134        fi
135        BRANCH="devel"
136        CODE_URL="https://codeload.github.com/opengnsys/OpenGnsys/zip/$BRANCH"
137        API_URL="https://api.github.com/repos/opengnsys/OpenGnsys/branches/$BRANCH"
138
139        # Directorios de instalación y destino de OpenGnsys.
140        WORKDIR=/tmp/opengnsys_installer
141        INSTALL_TARGET=/opt/opengnsys
142        PATH=$PATH:$INSTALL_TARGET/bin
143
144        # Registro de incidencias.
145        OGLOGFILE=$INSTALL_TARGET/log/${PROGRAMNAME%.sh}.log
146        LOG_FILE=/tmp/$(basename $OGLOGFILE)
147
148        # Usuario del cliente para acceso remoto.
149        OPENGNSYS_CLIENT_USER="opengnsys"
150        # Nombre de la base datos y fichero SQL para su creación.
151        OPENGNSYS_DATABASE="ogAdmBD"
152        OPENGNSYS_DB_CREATION_FILE=opengnsys/admin/Database/${OPENGNSYS_DATABASE}.sql
153}
[d168a46]154
155# Generar variables de configuración del instalador
156# Variables globales:
[5cc52295]157# - OSDISTRIB, OSVERSION - tipo y versión de la distribución GNU/Linux
[d168a46]158# - DEPENDENCIES - array de dependencias que deben estar instaladas
159# - UPDATEPKGLIST, INSTALLPKGS, CHECKPKGS - comandos para gestión de paquetes
[109e8b2]160# - INSTALLEXTRADEPS - instalar dependencias no incluidas en la distribución
[53fba30]161# - STARTSERVICE, ENABLESERVICE - iniciar y habilitar un servicio
[109e8b2]162# - STOPSERVICE, DISABLESERVICE - parar y deshabilitar un servicio
[53fba30]163# - APACHESERV, APACHECFGDIR, APACHESITESDIR, APACHEUSER, APACHEGROUP - servicio y configuración de Apache
[9215580]164# - APACHEENABLEMODS, APACHEENABLESSL, APACHEMAKECERT - habilitar módulos y certificado SSL
[5f21d34]165# - APACHEENABLEOG, APACHEOGSITE, - habilitar sitio web de OpenGnsys
[9215580]166# - PHPFPMSERV - servicio PHP FastCGI Process Manager para Apache
[53fba30]167# - INETDSERV - servicio Inetd
168# - DHCPSERV, DHCPCFGDIR - servicio y configuración de DHCP
[0f8100d]169# - MYSQLSERV, TMPMYCNF - servicio MySQL y fichero temporal con credenciales de acceso
170# - MARIADBSERV - servicio MariaDB (sustituto de MySQL en algunas distribuciones)
[e70925a]171# - RSYNCSERV, RSYNCCFGDIR - servicio y configuración de Rsync
[53fba30]172# - SAMBASERV, SAMBACFGDIR - servicio y configuración de Samba
[a16ce1b]173# - TFTPSERV, TFTPCFGDIR - servicio y configuración de TFTP/PXE
[d168a46]174function autoConfigure()
175{
[44f6582]176# Detectar sistema operativo del servidor (compatible con fichero os-release y con LSB).
177if [ -f /etc/os-release ]; then
178        source /etc/os-release
[eb7b39d]179        OSDISTRIB="$ID"
[5cc52295]180        OSVERSION="$VERSION_ID"
[44f6582]181else
182        OSDISTRIB=$(lsb_release -is 2>/dev/null)
[5cc52295]183        OSVERSION=$(lsb_release -rs 2>/dev/null)
[44f6582]184fi
[5cc52295]185# Convertir distribución a minúsculas y obtener solo el 1er número de versión.
[eb7b39d]186OSDISTRIB="${OSDISTRIB,,}"
[5cc52295]187OSVERSION="${OSVERSION%%.*}"
[d168a46]188
[eb7b39d]189# Configuración según la distribución GNU/Linux (usar minúsculas).
[d168a46]190case "$OSDISTRIB" in
[eb7b39d]191        ubuntu|debian|linuxmint)
[befd4f9]192                DEPENDENCIES=( subversion apache2 php php-ldap php-fpm mysql-server php-mysql isc-dhcp-server bittorrent tftp-hpa tftpd-hpa xinetd build-essential g++-multilib libmysqlclient-dev wget curl doxygen graphviz bittornado ctorrent samba rsync unzip netpipes debootstrap schroot squashfs-tools btrfs-tools procps arp-scan realpath php-curl gettext moreutils jq wakeonlan udpcast libev-dev libjansson-dev shim-signed grub-efi-amd64-signed )
[d168a46]193                UPDATEPKGLIST="apt-get update"
194                INSTALLPKG="apt-get -y install --force-yes"
195                CHECKPKG="dpkg -s \$package 2>/dev/null | grep Status | grep -qw install"
[53fba30]196                if which service &>/dev/null; then
[7ba85a4]197                        STARTSERVICE="eval service \$service restart"
[109e8b2]198                        STOPSERVICE="eval service \$service stop"
[53fba30]199                else
[7ba85a4]200                        STARTSERVICE="eval /etc/init.d/\$service restart"
[109e8b2]201                        STOPSERVICE="eval /etc/init.d/\$service stop"
[53fba30]202                fi
[7ba85a4]203                ENABLESERVICE="eval update-rc.d \$service defaults"
[109e8b2]204                DISABLESERVICE="eval update-rc.d \$service disable"
[53fba30]205                APACHESERV=apache2
[d168a46]206                APACHECFGDIR=/etc/apache2
[643ca8c]207                APACHESITESDIR=sites-available
[53fba30]208                APACHEOGSITE=opengnsys
[d168a46]209                APACHEUSER="www-data"
210                APACHEGROUP="www-data"
[9215580]211                APACHEENABLEMODS="a2enmod ssl rewrite proxy_fcgi fastcgi actions alias"
[7ba85a4]212                APACHEENABLESSL="a2ensite default-ssl"
[53fba30]213                APACHEENABLEOG="a2ensite $APACHEOGSITE"
[643ca8c]214                APACHEMAKECERT="make-ssl-cert generate-default-snakeoil --force-overwrite"
[53fba30]215                DHCPSERV=isc-dhcp-server
[83518d5]216                DHCPCFGDIR=/etc/dhcp
[f243a47]217                INETDSERV=xinetd
218                INETDCFGDIR=/etc/xinetd.d
[53fba30]219                MYSQLSERV=mysql
[0f8100d]220                MARIADBSERV=mariadb
[9215580]221                PHPFPMSERV=php-fpm
[e70925a]222                RSYNCSERV=rsync
223                RSYNCCFGDIR=/etc
[53fba30]224                SAMBASERV=smbd
[d168a46]225                SAMBACFGDIR=/etc/samba
226                TFTPCFGDIR=/var/lib/tftpboot
227                ;;
[eb7b39d]228        fedora|centos)
[5a07e02]229                DEPENDENCIES=( subversion httpd mod_ssl php-ldap php-fpm mysql-server mysql-devel mysql-devel.i686 php-mysql dhcp tftp-server tftp xinetd binutils gcc gcc-c++ glibc-devel glibc-devel.i686 glibc-static glibc-static.i686 libstdc++-devel.i686 make wget curl doxygen graphviz ctorrent samba samba-client rsync unzip debootstrap schroot squashfs-tools python-crypto arp-scan procps-ng gettext moreutils jq net-tools udpcast libev-devel shim-x64 grub2-efi-x64 grub2-efi-x64-modules http://ftp.altlinux.org/pub/distributions/ALTLinux/5.1/branch/$(arch)/RPMS.classic/netpipes-4.2-alt1.$(arch).rpm )
[97b6579]230                [ "$OSDISTRIB" == "centos" ] && UPDATEPKGLIST="yum install -y https://dl.fedoraproject.org/pub/epel/epel-release-latest-$OSVERSION.noarch.rpm http://rpms.remirepo.net/enterprise/remi-release-$OSVERSION.rpm"
231                INSTALLEXTRADEPS=( 'pushd /tmp; wget -t3 http://ftp.acc.umu.se/mirror/bittornado/BitTornado-0.3.18.tar.gz && tar xvzf BitTornado-0.3.18.tar.gz && cd BitTornado-CVS && python setup.py install && ln -fs btlaunchmany.py /usr/bin/btlaunchmany && ln -fs bttrack.py /usr/bin/bttrack; popd' )
232                INSTALLPKG="yum install -y libstdc++ libstdc++.i686"
[c79a2b3]233                CHECKPKG="rpm -q --quiet \$package"
[03cfd6e]234                SYSTEMD=$(which systemctl 2>/dev/null)
235                if [ -n "$SYSTEMD" ]; then
236                        STARTSERVICE="eval systemctl start \$service.service"
237                        STOPSERVICE="eval systemctl stop \$service.service"
238                        ENABLESERVICE="eval systemctl enable \$service.service"
239                        DISABLESERVICE="eval systemctl disable \$service.service"
240                else
241                        STARTSERVICE="eval service \$service start"
242                        STOPSERVICE="eval service \$service stop"
243                        ENABLESERVICE="eval chkconfig \$service on"
244                        DISABLESERVICE="eval chkconfig \$service off"
245                fi
[53fba30]246                APACHESERV=httpd
[d168a46]247                APACHECFGDIR=/etc/httpd/conf.d
[53fba30]248                APACHEOGSITE=opengnsys.conf
[d168a46]249                APACHEUSER="apache"
250                APACHEGROUP="apache"
[5f21d34]251                APACHEREWRITEMOD="sed -i '/rewrite/s/^#//' $APACHECFGDIR/../*.conf"
[53fba30]252                DHCPSERV=dhcpd
[d168a46]253                DHCPCFGDIR=/etc/dhcp
[53fba30]254                INETDSERV=xinetd
[f243a47]255                INETDCFGDIR=/etc/xinetd.d
[53fba30]256                MYSQLSERV=mysqld
[0f8100d]257                MARIADBSERV=mariadb
[ec536c6]258                PHPFPMSERV=php-fpm
[e70925a]259                RSYNCSERV=rsync
260                RSYNCCFGDIR=/etc
[53fba30]261                SAMBASERV=smb
[d168a46]262                SAMBACFGDIR=/etc/samba
[53fba30]263                TFTPSERV=tftp
[d168a46]264                TFTPCFGDIR=/var/lib/tftpboot
265                ;;
266        "")     echo "ERROR: Unknown Linux distribution, please install \"lsb_release\" command."
267                exit 1 ;;
[5f21d34]268        *)      echo "ERROR: Distribution not supported by OpenGnsys."
[d168a46]269                exit 1 ;;
270esac
[09bf701]271
272# Fichero de credenciales de acceso a MySQL.
273TMPMYCNF=/tmp/.my.cnf.$$
[d168a46]274}
275
[09ac3b8]276
[ff6c349]277# Modificar variables de configuración tras instalar paquetes del sistema.
278function autoConfigurePost()
279{
[e432478]280local f MKNETDIR
[09ac3b8]281
[44f6582]282# Configuraciones específicas para Samba y TFTP en Debian 6.
283[ -z "$SYSTEMD" -a ! -e /etc/init.d/$SAMBASERV ] && SAMBASERV=samba
284[ ! -e $TFTPCFGDIR ] && TFTPCFGDIR=/srv/tftp
285
[e432478]286# Preparar arranque en red con Grub.
287for f in grub-mknetdir grub2-mknetdir; do
288        if which $f &>/dev/null; then MKNETDIR=$f; fi
[09ac3b8]289done
[e432478]290$MKNETDIR --net-directory=$TFTPCFGDIR --subdir=grub
[ff6c349]291}
292
293
[83518d5]294# Cargar lista de paquetes del sistema y actualizar algunas variables de configuración
295# dependiendo de la versión instalada.
296function updatePackageList()
297{
[a37e5fc4]298local DHCPVERSION PHP7VERSION
[83518d5]299
300# Si es necesario, actualizar la lista de paquetes disponibles.
301[ -n "$UPDATEPKGLIST" ] && eval $UPDATEPKGLIST
302
303# Configuración personallizada de algunos paquetes.
304case "$OSDISTRIB" in
[eb7b39d]305        ubuntu|linuxmint)       # Postconfiguación personalizada para Ubuntu.
[83518d5]306                # Configuración para DHCP v3.
[e4b1572]307                DHCPVERSION=$(apt-cache show $(apt-cache pkgnames|egrep "dhcp.?-server$") | \
[83518d5]308                              awk '/Version/ {print substr($2,1,1);}' | \
309                              sort -n | tail -1)
310                if [ $DHCPVERSION = 3 ]; then
[e4b1572]311                        DEPENDENCIES=( ${DEPENDENCIES[@]/isc-dhcp-server/dhcp3-server} )
[53fba30]312                        DHCPSERV=dhcp3-server
[83518d5]313                        DHCPCFGDIR=/etc/dhcp3
314                fi
[a37e5fc4]315                # Configuración para PHP 7 en Ubuntu.
316                if [ -z "$(apt-cache pkgnames php7)" ]; then
[668f7dc]317                        eval $INSTALLPKG software-properties-common
[21f78d1]318                        add-apt-repository -y ppa:ondrej/php
[668f7dc]319                        eval $UPDATEPKGLIST
[5e4fb7e]320                        PHP7VERSION=$(apt-cache pkgnames php7 | sort | head -1)
[ec536c6]321                        PHPFPMSERV="${PHP7VERSION}-fpm"
[5e4fb7e]322                        DEPENDENCIES=( ${DEPENDENCIES[@]//php/$PHP7VERSION} )
[ad69c61]323                fi
[5e4fb7e]324                # Adaptar dependencias para libmysqlclient.
325                [ -z "$(apt-cache pkgnames libmysqlclient-dev)" ] && [ -n "$(apt-cache pkgnames libmysqlclient15)" ] && DEPENDENCIES=( ${DEPENDENCIES[@]//libmysqlclient-dev/libmysqlclient15} )
[9e64d82]326                # Paquete correcto para realpath.
327                [ -z "$(apt-cache pkgnames realpath)" ] && DEPENDENCIES=( ${DEPENDENCIES[@]//realpath/coreutils} )
[83518d5]328                ;;
[eb7b39d]329        centos) # Postconfiguación personalizada para CentOS.
[a37e5fc4]330                # Configuración para PHP 7.
[ec536c6]331                PHP7VERSION=$(yum list -q php7\* 2>/dev/null | awk -F. '/^php/ {print $1; exit;}')
[97b6579]332                PHPFPMSERV="${PHP7VERSION}-${PHPFPMSERV}"
333                DEPENDENCIES=( ${PHP7VERSION} ${DEPENDENCIES[@]//php/$PHP7VERSION-php} )
[2c8b9ed]334                # Cambios a aplicar a partir de CentOS 7.
335                if [ $OSVERSION -ge 7 ]; then
336                        # Sustituir MySQL por MariaDB.
337                        DEPENDENCIES=( ${DEPENDENCIES[*]/mysql-/mariadb-} )
[325aac9]338                        # Instalar ctorrent de EPEL para CentOS 6 (no disponible en CentOS 7).
339                        DEPENDENCIES=( ${DEPENDENCIES[*]/ctorrent/http://dl.fedoraproject.org/pub/epel/6/$(arch)/Packages/c/ctorrent-1.3.4-14.dnh3.3.2.el6.$(arch).rpm} )
[2c8b9ed]340                fi
[c525453]341                ;;
[eb7b39d]342        fedora) # Postconfiguación personalizada para Fedora.
[c525453]343                # Incluir paquetes específicos.
[325aac9]344                DEPENDENCIES=( ${DEPENDENCIES[@]} btrfs-progs )
[5cc52295]345                # Sustituir MySQL por MariaDB a partir de Fedora 20.
346                [ $OSVERSION -ge 20 ] && DEPENDENCIES=( ${DEPENDENCIES[*]/mysql-/mariadb-} )
[c79a2b3]347                ;;
[83518d5]348esac
349}
350
[d168a46]351
352#####################################################################
[a01156a]353####### Algunas funciones útiles de propósito general:
354#####################################################################
[d168a46]355
[13a01a7]356function getDateTime()
[a01156a]357{
[d168a46]358        date "+%Y%m%d-%H%M%S"
[a01156a]359}
360
361# Escribe a fichero y muestra por pantalla
[13a01a7]362function echoAndLog()
[a01156a]363{
[d168a46]364        local DATETIME=`getDateTime`
[87c7b02]365        echo "$1"
[d168a46]366        echo "$DATETIME;$SSH_CLIENT;$1" >> $LOG_FILE
[a01156a]367}
368
[87c7b02]369# Escribe a fichero y muestra mensaje de error
[13a01a7]370function errorAndLog()
[a01156a]371{
[d168a46]372        local DATETIME=`getDateTime`
[87c7b02]373        echo "ERROR: $1"
[d168a46]374        echo "$DATETIME;$SSH_CLIENT;ERROR: $1" >> $LOG_FILE
[a01156a]375}
376
[346eaee]377# Escribe a fichero y muestra mensaje de aviso
378function warningAndLog()
379{
380        local DATETIME=`getDateTime`
[cd86637]381        echo "Warning: $1"
[346eaee]382        echo "$DATETIME;$SSH_CLIENT;Warning: $1" >> $LOG_FILE
383}
384
[87c7b02]385# Comprueba si el elemento pasado en $2 está en el array $1
[13a01a7]386function isInArray()
[a01156a]387{
388        if [ $# -ne 2 ]; then
[13a01a7]389                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]390                exit 1
391        fi
392
393        local deps
[87c7b02]394        local is_in_array=1
395        local element="$2"
396
397        echoAndLog "${FUNCNAME}(): checking if $2 is in $1"
[5c33840]398        eval "deps=( \"\${$1[@]}\" )"
[a01156a]399
[87c7b02]400        # Copia local del array del parámetro 1.
401        for (( i = 0 ; i < ${#deps[@]} ; i++ )); do
402                if [ "${deps[$i]}" = "${element}" ]; then
403                        echoAndLog "isInArray(): $element found in array"
[a01156a]404                        is_in_array=0
405                fi
406        done
407
408        if [ $is_in_array -ne 0 ]; then
[87c7b02]409                echoAndLog "${FUNCNAME}(): $element NOT found in array"
[a01156a]410        fi
411
412        return $is_in_array
413}
414
[87c7b02]415
[a01156a]416#####################################################################
417####### Funciones de manejo de paquetes Debian
418#####################################################################
419
[13a01a7]420function checkPackage()
[a01156a]421{
422        package=$1
423        if [ -z $package ]; then
[73cfa0a]424                errorAndLog "${FUNCNAME}(): parameter required"
[a01156a]425                exit 1
426        fi
[73cfa0a]427        echoAndLog "${FUNCNAME}(): checking if package $package exists"
[d168a46]428        eval $CHECKPKG
[a01156a]429        if [ $? -eq 0 ]; then
[73cfa0a]430                echoAndLog "${FUNCNAME}(): package $package exists"
[a01156a]431                return 0
432        else
[73cfa0a]433                echoAndLog "${FUNCNAME}(): package $package doesn't exists"
[a01156a]434                return 1
435        fi
436}
437
[87c7b02]438# Recibe array con dependencias
[a01156a]439# por referencia deja un array con las dependencias no resueltas
440# devuelve 1 si hay alguna dependencia no resuelta
[13a01a7]441function checkDependencies()
[a01156a]442{
443        if [ $# -ne 2 ]; then
[73cfa0a]444                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]445                exit 1
446        fi
447
[73cfa0a]448        echoAndLog "${FUNCNAME}(): checking dependences"
[a01156a]449        uncompletedeps=0
450
451        # copia local del array del parametro 1
452        local deps
[5c33840]453        eval "deps=( \"\${$1[@]}\" )"
[a01156a]454
455        declare -a local_notinstalled
[5c33840]456
[a01156a]457        for (( i = 0 ; i < ${#deps[@]} ; i++ ))
458        do
459                checkPackage ${deps[$i]}
460                if [ $? -ne 0 ]; then
461                        local_notinstalled[$uncompletedeps]=$package
462                        let uncompletedeps=uncompletedeps+1
463                fi
464        done
465
466        # relleno el array especificado en $2 por referencia
467        for (( i = 0 ; i < ${#local_notinstalled[@]} ; i++ ))
468        do
469                eval "${2}[$i]=${local_notinstalled[$i]}"
470        done
471
472        # retorna el numero de paquetes no resueltos
[73cfa0a]473        echoAndLog "${FUNCNAME}(): dependencies uncompleted: $uncompletedeps"
[a01156a]474        return $uncompletedeps
475}
476
477# Recibe un array con las dependencias y lo instala
[13a01a7]478function installDependencies()
[a01156a]479{
480        if [ $# -ne 1 ]; then
[813f617]481                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]482                exit 1
483        fi
[813f617]484        echoAndLog "${FUNCNAME}(): installing uncompleted dependencies"
[a01156a]485
486        # copia local del array del parametro 1
487        local deps
[5c33840]488        eval "deps=( \"\${$1[@]}\" )"
[a01156a]489
490        local string_deps=""
491        for (( i = 0 ; i < ${#deps[@]} ; i++ ))
492        do
493                string_deps="$string_deps ${deps[$i]}"
494        done
495
496        if [ -z "${string_deps}" ]; then
[813f617]497                errorAndLog "${FUNCNAME}(): array of dependeces is empty"
[a01156a]498                exit 1
499        fi
500
[c79a2b3]501        OLD_DEBIAN_FRONTEND=$DEBIAN_FRONTEND            # Debian/Ubuntu
[a01156a]502        export DEBIAN_FRONTEND=noninteractive
503
[d168a46]504        echoAndLog "${FUNCNAME}(): now $string_deps will be installed"
505        eval $INSTALLPKG $string_deps
[a01156a]506        if [ $? -ne 0 ]; then
[813f617]507                errorAndLog "${FUNCNAME}(): error installing dependencies"
[a01156a]508                return 1
509        fi
510
[c79a2b3]511        DEBIAN_FRONTEND=$OLD_DEBIAN_FRONTEND            # Debian/Ubuntu
[6019b12]512        test grep -q "EPEL temporal" /etc/yum.repos.d/epel.repo 2>/dev/null || mv -f /etc/yum.repos.d/epel.repo.rpmnew /etc/yum.repos.d/epel.repo 2>/dev/null   # CentOS/RedHat EPEL
[c79a2b3]513
[813f617]514        echoAndLog "${FUNCNAME}(): dependencies installed"
[a01156a]515}
516
[13a01a7]517# Hace un backup del fichero pasado por parámetro
518# deja un -last y uno para el día
519function backupFile()
520{
521        if [ $# -ne 1 ]; then
522                errorAndLog "${FUNCNAME}(): invalid number of parameters"
523                exit 1
524        fi
525
[d168a46]526        local file="$1"
527        local dateymd=`date +%Y%m%d`
[13a01a7]528
[d168a46]529        if [ ! -f "$file" ]; then
[346eaee]530                warningAndLog "${FUNCNAME}(): file $file doesn't exists"
[13a01a7]531                return 1
532        fi
533
[d168a46]534        echoAndLog "${FUNCNAME}(): making $file backup"
[13a01a7]535
536        # realiza una copia de la última configuración como last
[d168a46]537        cp -a "$file" "${file}-LAST"
[13a01a7]538
539        # si para el día no hay backup lo hace, sino no
[d168a46]540        if [ ! -f "${file}-${dateymd}" ]; then
541                cp -a "$file" "${file}-${dateymd}"
[13a01a7]542        fi
543
[d168a46]544        echoAndLog "${FUNCNAME}(): $file backup success"
[13a01a7]545}
546
[a01156a]547#####################################################################
548####### Funciones para el manejo de bases de datos
549#####################################################################
550
551# This function set password to root
[13a01a7]552function mysqlSetRootPassword()
[a01156a]553{
554        if [ $# -ne 1 ]; then
[813f617]555                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]556                exit 1
557        fi
558
[e0edc14]559        local root_mysql="$1"
[813f617]560        echoAndLog "${FUNCNAME}(): setting root password in MySQL server"
[e0edc14]561        mysqladmin -u root password "$root_mysql"
[a01156a]562        if [ $? -ne 0 ]; then
[813f617]563                errorAndLog "${FUNCNAME}(): error while setting root password in MySQL server"
[a01156a]564                return 1
565        fi
[813f617]566        echoAndLog "${FUNCNAME}(): root password saved!"
[a01156a]567        return 0
568}
569
[892606b9]570# Si el servicio mysql esta ya instalado cambia la variable de la clave del root por la ya existente
[e0edc14]571function mysqlGetRootPassword()
572{
[892606b9]573        local pass_mysql
574        local pass_mysql2
[7c54b49]575        # Comprobar si MySQL está instalado con la clave de root por defecto.
576        if mysql -u root -p"$MYSQL_ROOT_PASSWORD" <<<"quit" 2>/dev/null; then
577                echoAndLog "${FUNCNAME}(): Using default mysql root password."
578        else
579                stty -echo
[e0edc14]580                echo "There is a MySQL service already installed."
581                read -p "Enter MySQL root password: " pass_mysql
[7c54b49]582                echo ""
[e0edc14]583                read -p "Confrim password:" pass_mysql2
[7c54b49]584                echo ""
585                stty echo
586                if [ "$pass_mysql" == "$pass_mysql2" ] ;then
[e0edc14]587                        MYSQL_ROOT_PASSWORD="$pass_mysql"
[7c54b49]588                        return 0
589                else
[e0edc14]590                        echo "The keys don't match. Do not configure the server's key,"
591                        echo "transactions in the database will give error."
[7c54b49]592                        return 1
593                fi
[892606b9]594        fi
595}
596
[a01156a]597# comprueba si puede conectar con mysql con el usuario root
598function mysqlTestConnection()
599{
600        if [ $# -ne 1 ]; then
[e0edc14]601                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]602                exit 1
603        fi
604
[09bf701]605        local root_password="$1"
[e0edc14]606        echoAndLog "${FUNCNAME}(): checking connection to mysql..."
[09bf701]607        # Componer fichero con credenciales de conexión a MySQL.
608        touch $TMPMYCNF
609        chmod 600 $TMPMYCNF
610        cat << EOT > $TMPMYCNF
[c073224]611[client]
[09bf701]612user=root
613password=$root_password
614EOT
615        # Borrar el fichero temporal si termina el proceso de instalación.
616        trap "rm -f $TMPMYCNF" 0 1 2 3 6 9 15
617        # Comprobar conexión a MySQL.
618        echo "" | mysql --defaults-extra-file=$TMPMYCNF
[a01156a]619        if [ $? -ne 0 ]; then
[e0edc14]620                errorAndLog "${FUNCNAME}(): connection to mysql failed, check root password and if daemon is running!"
[a01156a]621                return 1
622        else
[e0edc14]623                echoAndLog "${FUNCNAME}(): connection success"
[a01156a]624                return 0
625        fi
626}
627
628# comprueba si la base de datos existe
629function mysqlDbExists()
630{
[09bf701]631        if [ $# -ne 1 ]; then
[e0edc14]632                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]633                exit 1
634        fi
635
[09bf701]636        local database="$1"
[e0edc14]637        echoAndLog "${FUNCNAME}(): checking if $database exists..."
[09bf701]638        echo "show databases" | mysql --defaults-extra-file=$TMPMYCNF | grep "^${database}$"
[a01156a]639        if [ $? -ne 0 ]; then
[e0edc14]640                echoAndLog "${FUNCNAME}():database $database doesn't exists"
[a01156a]641                return 1
642        else
[e0edc14]643                echoAndLog "${FUNCNAME}():database $database exists"
[a01156a]644                return 0
645        fi
646}
647
[0a735488]648# Comprueba si la base de datos está vacía.
[a01156a]649function mysqlCheckDbIsEmpty()
650{
[09bf701]651        if [ $# -ne 1 ]; then
[e0edc14]652                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]653                exit 1
654        fi
655
[09bf701]656        local database="$1"
[e0edc14]657        echoAndLog "${FUNCNAME}(): checking if $database is empty..."
[09bf701]658        num_tablas=`echo "show tables" | mysql --defaults-extra-file=$TMPMYCNF "${database}" | wc -l`
[a01156a]659        if [ $? -ne 0 ]; then
[e0edc14]660                errorAndLog "${FUNCNAME}(): error executing query, check database and root password"
[a01156a]661                exit 1
662        fi
663
664        if [ $num_tablas -eq 0 ]; then
[e0edc14]665                echoAndLog "${FUNCNAME}():database $database is empty"
[a01156a]666                return 0
667        else
[e0edc14]668                echoAndLog "${FUNCNAME}():database $database has tables"
[a01156a]669                return 1
670        fi
671
672}
673
[0a735488]674# Importa un fichero SQL en la base de datos.
675# Parámetros:
676# - 1: nombre de la BD.
677# - 2: fichero a importar.
678# Nota: el fichero SQL puede contener las siguientes palabras reservadas:
679# - SERVERIP: se sustituye por la dirección IP del servidor.
680# - DBUSER: se sustituye por usuario de conexión a la BD definido en este script.
681# - DBPASSWD: se sustituye por la clave de conexión a la BD definida en este script.
[a01156a]682function mysqlImportSqlFileToDb()
683{
[09bf701]684        if [ $# -ne 2 ]; then
[c5ce04c]685                errorAndLog "${FNCNAME}(): invalid number of parameters"
[a01156a]686                exit 1
687        fi
688
[09bf701]689        local database="$1"
690        local sqlfile="$2"
[c4321ae]691        local tmpfile=$(mktemp)
[d168a46]692        local i=0
693        local dev=""
[c4321ae]694        local status
[8e0f770]695        # Claves aleatorias para acceso a las APIs REST.
[7829e4e]696        local OPENGNSYS_APIKEY=$(php -r 'echo md5(uniqid(rand(), true));')
[f9b5714]697        OPENGNSYS_REPOKEY=$(php -r 'echo md5(uniqid(rand(), true));')
[a01156a]698
699        if [ ! -f $sqlfile ]; then
[c5ce04c]700                errorAndLog "${FUNCNAME}(): Unable to locate $sqlfile!!"
[a01156a]701                return 1
702        fi
703
[d168a46]704        echoAndLog "${FUNCNAME}(): importing SQL file to ${database}..."
[c4321ae]705        chmod 600 $tmpfile
[d168a46]706        for dev in ${DEVICE[*]}; do
[73a1bd6]707                if [ "${DEVICE[i]}" == "$DEFAULTDEV" ]; then
[d168a46]708                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
709                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
710                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
[7829e4e]711                            -e "s/APIKEY/$OPENGNSYS_APIKEY/g" \
[8e0f770]712                            -e "s/REPOKEY/$OPENGNSYS_REPOKEY/g" \
[d168a46]713                                $sqlfile > $tmpfile
714                fi
715                let i++
716        done
[09bf701]717        mysql --defaults-extra-file=$TMPMYCNF --default-character-set=utf8 "${database}" < $tmpfile
[c4321ae]718        status=$?
719        rm -f $tmpfile
720        if [ $status -ne 0 ]; then
[c5ce04c]721                errorAndLog "${FUNCNAME}(): error while importing $sqlfile in database $database"
[a01156a]722                return 1
723        fi
[c5ce04c]724        echoAndLog "${FUNCNAME}(): file imported to database $database"
[a01156a]725        return 0
726}
727
728# Crea la base de datos
729function mysqlCreateDb()
730{
[09bf701]731        if [ $# -ne 1 ]; then
[a555f49]732                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]733                exit 1
734        fi
735
[09bf701]736        local database="$1"
[a01156a]737
[a555f49]738        echoAndLog "${FUNCNAME}(): creating database..."
[09bf701]739        mysqladmin --defaults-extra-file=$TMPMYCNF create $database
[a01156a]740        if [ $? -ne 0 ]; then
[a555f49]741                errorAndLog "${FUNCNAME}(): error while creating database $database"
[a01156a]742                return 1
743        fi
[e47e131]744        # Quitar modo ONLY_FULL_GROUP_BY de MySQL (ticket #730).
745        mysql --defaults-extra-file=$TMPMYCNF -e "SET GLOBAL sql_mode=(SELECT TRIM(BOTH ',' FROM REPLACE(@@sql_mode,'ONLY_FULL_GROUP_BY','')));"
746
[a555f49]747        echoAndLog "${FUNCNAME}(): database $database created"
[a01156a]748        return 0
749}
750
[0a735488]751# Comprueba si ya está definido el usuario de acceso a la BD.
[a01156a]752function mysqlCheckUserExists()
753{
[09bf701]754        if [ $# -ne 1 ]; then
[e0edc14]755                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]756                exit 1
757        fi
758
[09bf701]759        local userdb="$1"
[a01156a]760
[e0edc14]761        echoAndLog "${FUNCNAME}(): checking if $userdb exists..."
[09bf701]762        echo "select user from user where user='${userdb}'\\G" |mysql --defaults-extra-file=$TMPMYCNF mysql | grep user
[a01156a]763        if [ $? -ne 0 ]; then
[e0edc14]764                echoAndLog "${FUNCNAME}(): user doesn't exists"
[a01156a]765                return 1
766        else
[e0edc14]767                echoAndLog "${FUNCNAME}(): user already exists"
[a01156a]768                return 0
769        fi
770
771}
772
773# Crea un usuario administrativo para la base de datos
774function mysqlCreateAdminUserToDb()
775{
[09bf701]776        if [ $# -ne 3 ]; then
[e0edc14]777                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]778                exit 1
779        fi
780
[09bf701]781        local database="$1"
782        local userdb="$2"
783        local passdb="$3"
[a01156a]784
[e0edc14]785        echoAndLog "${FUNCNAME}(): creating admin user ${userdb} to database ${database}"
[a01156a]786
787        cat > $WORKDIR/create_${database}.sql <<EOF
788GRANT USAGE ON *.* TO '${userdb}'@'localhost' IDENTIFIED BY '${passdb}' ;
789GRANT ALL PRIVILEGES ON ${database}.* TO '${userdb}'@'localhost' WITH GRANT OPTION ;
790FLUSH PRIVILEGES ;
791EOF
[09bf701]792        mysql --defaults-extra-file=$TMPMYCNF < $WORKDIR/create_${database}.sql
[a01156a]793        if [ $? -ne 0 ]; then
[e0edc14]794                errorAndLog "${FUNCNAME}(): error while creating user in mysql"
[a01156a]795                rm -f $WORKDIR/create_${database}.sql
796                return 1
797        else
[e0edc14]798                echoAndLog "${FUNCNAME}(): user created ok"
[a01156a]799                rm -f $WORKDIR/create_${database}.sql
800                return 0
801        fi
802}
803
804
805#####################################################################
[884b6ce]806####### Funciones para la descarga de código
[a01156a]807#####################################################################
808
[884b6ce]809# Obtiene el código fuente del proyecto desde el repositorio de GitHub.
810function downloadCode()
[13a01a7]811{
812        if [ $# -ne 1 ]; then
813                errorAndLog "${FUNCNAME}(): invalid number of parameters"
814                exit 1
815        fi
816
[6090a2d]817        local url="$1"
[13a01a7]818
[884b6ce]819        echoAndLog "${FUNCNAME}(): downloading code..."
[13a01a7]820
[884b6ce]821        curl "${url}" -o opengnsys.zip && unzip opengnsys.zip && mv "OpenGnsys-$BRANCH" opengnsys
[13a01a7]822        if [ $? -ne 0 ]; then
[5f21d34]823                errorAndLog "${FUNCNAME}(): error getting OpenGnsys code from $url"
[13a01a7]824                return 1
825        fi
[884b6ce]826        rm -f opengnsys.zip
827        echoAndLog "${FUNCNAME}(): code was downloaded"
[13a01a7]828        return 0
829}
830
831
[892606b9]832############################################################
[7586ca3]833###  Detectar red
834############################################################
835
[07c3a59]836# Comprobar si existe conexión.
837function checkNetworkConnection()
838{
[6bd2e1e]839        echoAndLog "${FUNCNAME}(): Checking OpenGnsys server connectivity."
[a0081b7]840        OPENGNSYS_SERVER=${OPENGNSYS_SERVER:-"opengnsys.es"}
[225e859]841        if which wget &>/dev/null; then
842                wget --spider -q $OPENGNSYS_SERVER
843        elif which curl &>/dev/null; then
844                curl --connect-timeout 10 -s $OPENGNSYS_SERVER -o /dev/null
845        else
846                echoAndLog "${FUNCNAME}(): Cannot execute \"wget\" nor \"curl\"."
847                return 1
848        fi
[07c3a59]849}
850
[140fbd5]851# Convierte nº de bits (notación CIDR) en máscara de red (gracias a FriedZombie en openwrt.org).
852cidr2mask ()
853{
854        # Number of args to shift, 255..255, first non-255 byte, zeroes
855        set -- $[ 5 - ($1 / 8) ] 255 255 255 255 $[ (255 << (8 - ($1 % 8))) & 255 ] 0 0 0
856        [ $1 -gt 1 ] && shift $1 || shift
857        echo ${1-0}.${2-0}.${3-0}.${4-0}
858}
859
[07c3a59]860# Obtener los parámetros de red de la interfaz por defecto.
[7586ca3]861function getNetworkSettings()
862{
[d168a46]863        # Arrays globales definidas:
864        # - DEVICE:     nombres de dispositivos de red activos.
865        # - SERVERIP:   IPs locales del servidor.
866        # - NETIP:      IPs de redes.
867        # - NETMASK:    máscaras de red.
868        # - NETBROAD:   IPs de difusión de redes.
869        # - ROUTERIP:   IPs de routers.
870        # Otras variables globales:
871        # - DEFAULTDEV: dispositivo de red por defecto.
872        # - DNSIP:      IP del servidor DNS principal.
873
874        local i=0
875        local dev=""
876
[109e8b2]877        echoAndLog "${FUNCNAME}(): Detecting network parameters."
[d168a46]878        DEVICE=( $(ip -o link show up | awk '!/loopback/ {sub(/:.*/,"",$2); print $2}') )
879        if [ -z "$DEVICE" ]; then
880                errorAndLog "${FUNCNAME}(): Network devices not detected."
[62e3bcf]881                exit 1
882        fi
[d168a46]883        for dev in ${DEVICE[*]}; do
[2c1b0cf]884                SERVERIP[i]=$(ip -o addr show dev "$dev" | awk '$3~/inet$/ {sub (/\/.*/, ""); print ($4); exit;}')
[d168a46]885                if [ -n "${SERVERIP[i]}" ]; then
[2c1b0cf]886                        NETMASK[i]=$( cidr2mask $(ip -o addr show dev "$dev" | awk '$3~/inet$/ {sub (/.*\//, "", $4); print ($4); exit;}') )
887                        NETBROAD[i]=$(ip -o addr show dev "$dev" | awk '$3~/inet$/ {print ($6); exit;}')
888                        NETIP[i]=$(ip route list proto kernel | awk -v d="$dev" '$3==d && /src/ {sub (/\/.*/,""); print $1; exit;}')
889                        ROUTERIP[i]=$(ip route list default | awk -v d="$dev" '$5==d {print $3; exit;}')
[d168a46]890                        DEFAULTDEV=${DEFAULTDEV:-"$dev"}
891                fi
[ce85ae8]892                let i++
[d168a46]893        done
[2c1b0cf]894        DNSIP=$(systemd-resolve --status 2>/dev/null | awk '/DNS Servers:/ {print $3; exit;}')
895        [ -z "$DNSIP" ] && DNSIP=$(awk '/nameserver/ {print $2; exit;}' /etc/resolv.conf)
[03cfd6e]896        if [ -z "${NETIP[*]}" -o -z "${NETMASK[*]}" ]; then
[62e3bcf]897                errorAndLog "${FUNCNAME}(): Network not detected."
[7586ca3]898                exit 1
899        fi
[cc7eab7]900
901        # Variables de ejecución de Apache
902        # - APACHE_RUN_USER
903        # - APACHE_RUN_GROUP
[d168a46]904        if [ -f $APACHECFGDIR/envvars ]; then
905                source $APACHECFGDIR/envvars
[cc7eab7]906        fi
[d168a46]907        APACHE_RUN_USER=${APACHE_RUN_USER:-"$APACHEUSER"}
908        APACHE_RUN_GROUP=${APACHE_RUN_GROUP:-"$APACHEGROUP"}
[73a1bd6]909
910        echoAndLog "${FUNCNAME}(): Default network device: $DEFAULTDEV."
[7586ca3]911}
912
913
914############################################################
[892606b9]915### Esqueleto para el Servicio pxe y contenedor tftpboot ###
916############################################################
917
[e0edc14]918function tftpConfigure()
919{
[109e8b2]920        echoAndLog "${FUNCNAME}(): Configuring TFTP service."
921        # Habilitar TFTP y reiniciar Inetd.
[8244351]922        if [ -n "$TFTPSERV" ]; then
[584b103]923                if [ -f $INETDCFGDIR/$TFTPSERV ]; then
924                        perl -pi -e 's/disable.*/disable = no/' $INETDCFGDIR/$TFTPSERV
925                else
926                        service=$TFTPSERV
[b8969db]927                        $ENABLESERVICE; $STARTSERVICE
[584b103]928                fi
[8244351]929        fi
[53fba30]930        service=$INETDSERV
931        $ENABLESERVICE; $STARTSERVICE
[892606b9]932
[297df16]933        # comprobamos el servicio tftp
934        sleep 1
935        testPxe
[892606b9]936}
937
[0a735488]938# Comprueba que haya conexión al servicio TFTP/PXE.
[e0edc14]939function testPxe ()
940{
[297df16]941        echoAndLog "${FUNCNAME}(): Checking TFTP service... please wait."
[beaebf8]942        echo "test" >$TFTPCFGDIR/testpxe
943        tftp -v 127.0.0.1 -c get testpxe /tmp/testpxe && echoAndLog "TFTP service is OK." || errorAndLog "TFTP service is down."
944        rm -f $TFTPCFGDIR/testpxe /tmp/testpxe
[e4b1572]945}
946
947
948########################################################################
[5f21d34]949## Configuración servicio Samba
[8fc9552]950########################################################################
[e4b1572]951
952# Configurar servicios Samba.
[8fc9552]953function smbConfigure()
954{
[e0edc14]955        echoAndLog "${FUNCNAME}(): Configuring Samba service."
[8fc9552]956
[d168a46]957        backupFile $SAMBACFGDIR/smb.conf
[8fc9552]958       
[5f21d34]959        # Copiar plantailla de recursos para OpenGnsys
[c1e00e4]960        sed -e "s/OPENGNSYSDIR/${INSTALL_TARGET//\//\\/}/g" \
[d168a46]961                $WORKDIR/opengnsys/server/etc/smb-og.conf.tmpl > $SAMBACFGDIR/smb-og.conf
[813f617]962        # Configurar y recargar Samba"
[5f21d34]963        perl -pi -e "s/WORKGROUP/OPENGNSYS/; s/server string \=.*/server string \= OpenGnsys Samba Server/" $SAMBACFGDIR/smb.conf
[03cfd6e]964        if ! grep -q "smb-og" $SAMBACFGDIR/smb.conf; then
965                echo "include = $SAMBACFGDIR/smb-og.conf" >> $SAMBACFGDIR/smb.conf
966        fi
[53fba30]967        service=$SAMBASERV
968        $ENABLESERVICE; $STARTSERVICE
[8fc9552]969        if [ $? -ne 0 ]; then
[813f617]970                errorAndLog "${FUNCNAME}(): error while configure Samba"
[8fc9552]971                return 1
972        fi
[eb9424f]973        # Crear clave para usuario de acceso a los recursos.
[813f617]974        echo -ne "$OPENGNSYS_CLIENT_PASSWD\n$OPENGNSYS_CLIENT_PASSWD\n" | smbpasswd -a -s $OPENGNSYS_CLIENT_USER
[8fc9552]975
[813f617]976        echoAndLog "${FUNCNAME}(): Added Samba configuration."
[8fc9552]977        return 0
978}
979
980
[b6906f7]981########################################################################
[5f21d34]982## Configuración servicio Rsync
[e70925a]983########################################################################
984
985# Configurar servicio Rsync.
986function rsyncConfigure()
987{
988        echoAndLog "${FUNCNAME}(): Configuring Rsync service."
989
990        backupFile $RSYNCCFGDIR/rsyncd.conf
991
992        # Configurar acceso a Rsync.
993        sed -e "s/CLIENTUSER/$OPENGNSYS_CLIENT_USER/g" \
994                $WORKDIR/opengnsys/repoman/etc/rsyncd.conf.tmpl > $RSYNCCFGDIR/rsyncd.conf
995        # Habilitar Rsync y reiniciar Inetd.
996        if [ -n "$RSYNCSERV" ]; then
[4666588]997                if [ -f /etc/default/rsync ]; then
998                        perl -pi -e 's/RSYNC_ENABLE=.*/RSYNC_ENABLE=inetd/' /etc/default/rsync
999                fi
[f243a47]1000                if [ -f $INETDCFGDIR/rsync ]; then
1001                        perl -pi -e 's/disable.*/disable = no/' $INETDCFGDIR/rsync
1002                else
1003                        cat << EOT > $INETDCFGDIR/rsync
1004service rsync
1005{
1006        disable = no
1007        socket_type = stream
1008        wait = no
1009        user = root
1010        server = $(which rsync)
1011        server_args = --daemon
1012        log_on_failure += USERID
1013        flags = IPv6
1014}
1015EOT
1016                fi
[e70925a]1017                service=$RSYNCSERV $ENABLESERVICE
1018                service=$INETDSERV $STARTSERVICE
1019        fi
1020
1021        echoAndLog "${FUNCNAME}(): Added Rsync configuration."
1022        return 0
1023}
1024
1025       
1026########################################################################
[5f21d34]1027## Configuración servicio DHCP
[b6906f7]1028########################################################################
1029
[e4b1572]1030# Configurar servicios DHCP.
[7586ca3]1031function dhcpConfigure()
1032{
[836a7597]1033        echoAndLog "${FUNCNAME}(): Sample DHCP configuration."
[a555f49]1034
[d168a46]1035        local errcode=0
1036        local i=0
1037        local dev=""
1038
1039        backupFile $DHCPCFGDIR/dhcpd.conf
1040        for dev in ${DEVICE[*]}; do
[01a9904]1041                if [ -n "${SERVERIP[i]}" ]; then
[d168a46]1042                        backupFile $DHCPCFGDIR/dhcpd-$dev.conf
[e4b1572]1043                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1044                            -e "s/NETIP/${NETIP[i]}/g" \
1045                            -e "s/NETMASK/${NETMASK[i]}/g" \
1046                            -e "s/NETBROAD/${NETBROAD[i]}/g" \
1047                            -e "s/ROUTERIP/${ROUTERIP[i]}/g" \
[d168a46]1048                            -e "s/DNSIP/$DNSIP/g" \
1049                            $WORKDIR/opengnsys/server/etc/dhcpd.conf.tmpl > $DHCPCFGDIR/dhcpd-$dev.conf || errcode=1
1050                fi
1051                let i++
1052        done
1053        if [ $errcode -ne 0 ]; then
[b25fc47]1054                errorAndLog "${FUNCNAME}(): error while configuring DHCP server"
[a555f49]1055                return 1
1056        fi
[d168a46]1057        ln -f $DHCPCFGDIR/dhcpd-$DEFAULTDEV.conf $DHCPCFGDIR/dhcpd.conf
[53fba30]1058        service=$DHCPSERV
1059        $ENABLESERVICE; $STARTSERVICE
[d168a46]1060        echoAndLog "${FUNCNAME}(): Sample DHCP configured in \"$DHCPCFGDIR\"."
[a555f49]1061        return 0
[892606b9]1062}
1063
1064
[a01156a]1065#####################################################################
1066####### Funciones específicas de la instalación de Opengnsys
1067#####################################################################
1068
[5f21d34]1069# Copiar ficheros del OpenGnsys Web Console.
[7586ca3]1070function installWebFiles()
1071{
[2b793a8]1072        local COMPATDIR f
[7829e4e]1073        local SLIMFILE="slim-2.6.1.zip"
[8b8e948]1074        local SWAGGERFILE="swagger-ui-2.2.5.zip"
[2b793a8]1075
[dce072b]1076        echoAndLog "${FUNCNAME}(): Installing web files..."
[2b793a8]1077        # Copiar ficheros.
1078        cp -a $WORKDIR/opengnsys/admin/WebConsole/* $INSTALL_TARGET/www   #*/ comentario para Doxygen.
[7586ca3]1079        if [ $? != 0 ]; then
[dce072b]1080                errorAndLog "${FUNCNAME}(): Error copying web files."
[7586ca3]1081                exit 1
1082        fi
[7829e4e]1083
[1635f45]1084        # Descomprimir librerías: Slim y Swagger-UI.
[7829e4e]1085        unzip -o $WORKDIR/opengnsys/admin/$SLIMFILE -d $INSTALL_TARGET/www/rest
[8b8e948]1086        unzip -o $WORKDIR/opengnsys/admin/$SWAGGERFILE -d $INSTALL_TARGET/www/rest
[7829e4e]1087
[2b793a8]1088        # Compatibilidad con dispositivos móviles.
1089        COMPATDIR="$INSTALL_TARGET/www/principal"
1090        for f in acciones administracion aula aulas hardwares imagenes menus repositorios softwares; do
1091                sed 's/clickcontextualnodo/clicksupnodo/g' $COMPATDIR/$f.php > $COMPATDIR/$f.device.php
1092        done
1093        cp -a $COMPATDIR/imagenes.device.php $COMPATDIR/imagenes.device4.php
[aafe8f9]1094        # Acceso al manual de usuario
1095        ln -fs ../doc/userManual $INSTALL_TARGET/www/userManual
[0645906]1096        # Ficheros de log de la API REST.
1097        touch $INSTALL_TARGET/log/{ogagent,remotepc,rest}.log
[2b793a8]1098
[dce072b]1099        echoAndLog "${FUNCNAME}(): Web files installed successfully."
[7586ca3]1100}
1101
[ec045b1]1102# Copiar ficheros en la zona de descargas de OpenGnsys Web Console.
1103function installDownloadableFiles()
1104{
1105        local FILENAME=ogagentpkgs-$INSTVERSION.tar.gz
1106        local TARGETFILE=$WORKDIR/$FILENAME
1107 
1108        # Descargar archivo comprimido, si es necesario.
1109        if [ -s $PROGRAMDIR/$FILENAME ]; then
1110                echoAndLog "${FUNCNAME}(): Moving $PROGRAMDIR/$FILENAME file to $(dirname $TARGETFILE)"
1111                mv $PROGRAMDIR/$FILENAME $TARGETFILE
1112        else
1113                echoAndLog "${FUNCNAME}(): Downloading $FILENAME"
[d5cbfa8]1114                curl $DOWNLOADURL/$FILENAME -o $TARGETFILE
[ec045b1]1115        fi
1116        if [ ! -s $TARGETFILE ]; then
1117                errorAndLog "${FUNCNAME}(): Cannot download $FILENAME"
1118                return 1
1119        fi
1120       
1121        # Descomprimir fichero en zona de descargas.
1122        tar xvzf $TARGETFILE -C $INSTALL_TARGET/www/descargas
1123        if [ $? != 0 ]; then
1124                errorAndLog "${FUNCNAME}(): Error uncompressing archive."
1125                exit 1
1126        fi
1127}
1128
[7586ca3]1129# Configuración específica de Apache.
[73a1bd6]1130function installWebConsoleApacheConf()
[a01156a]1131{
1132        if [ $# -ne 2 ]; then
[dce072b]1133                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]1134                exit 1
1135        fi
1136
[f9e3393]1137        local path_opengnsys_base="$1"
1138        local path_apache2_confd="$2"
[30837bb]1139        local CONSOLEDIR=${path_opengnsys_base}/www
[9215580]1140        local sockfile
[a01156a]1141
[892606b9]1142        if [ ! -d $path_apache2_confd ]; then
[dce072b]1143                errorAndLog "${FUNCNAME}(): path to apache2 conf.d can not found, verify your server installation"
[892606b9]1144                return 1
1145        fi
1146
[7586ca3]1147        mkdir -p $path_apache2_confd/{sites-available,sites-enabled}
[892606b9]1148
[dce072b]1149        echoAndLog "${FUNCNAME}(): creating apache2 config file.."
[a01156a]1150
[9215580]1151        # Avtivar PHP-FPM.
1152        echoAndLog "${FUNCNAME}(): configuring PHP-FPM"
1153        service=$PHPFPMSERV
1154        $ENABLESERVICE; $STARTSERVICE
[e432478]1155        sockfile=$(find /run/php -name "php*.sock" -type s -print 2>/dev/null | tail -1)
[9215580]1156
1157        # Activar módulos de Apache.
1158        $APACHEENABLEMODS
[3ce53a7]1159        # Activar HTTPS.
[643ca8c]1160        $APACHEENABLESSL
1161        $APACHEMAKECERT
[30837bb]1162        # Genera configuración de consola web a partir del fichero plantilla.
[f9e3393]1163        if [ -n "$(apachectl -v | grep "2\.[0-2]")" ]; then
1164                # Configuración para versiones anteriores de Apache.
[6f4d39b]1165                sed -e "s,CONSOLEDIR,$CONSOLEDIR,g" \
[f3dde7e]1166                        $WORKDIR/opengnsys/server/etc/apache-prev2.4.conf.tmpl > $path_apache2_confd/$APACHESITESDIR/${APACHEOGSITE}
[f9e3393]1167        else
1168                # Configuración específica a partir de Apache 2.4
[37481d8]1169                if [ -n "$sockfile" ]; then
1170                        sed -e "s,CONSOLEDIR,$CONSOLEDIR,g" \
1171                            -e "s,proxy:fcgi:.*,proxy:unix:${sockfile%% *}|fcgi://localhost\",g" \
1172                                $WORKDIR/opengnsys/server/etc/apache.conf.tmpl > $path_apache2_confd/$APACHESITESDIR/${APACHEOGSITE}.conf
1173                else
1174                        sed -e "s,CONSOLEDIR,$CONSOLEDIR,g" \
1175                                $WORKDIR/opengnsys/server/etc/apache.conf.tmpl > $path_apache2_confd/$APACHESITESDIR/${APACHEOGSITE}.conf
1176                fi
[f9e3393]1177        fi
[643ca8c]1178        $APACHEENABLEOG
[a01156a]1179        if [ $? -ne 0 ]; then
[dce072b]1180                errorAndLog "${FUNCNAME}(): config file can't be linked to apache conf, verify your server installation"
[a01156a]1181                return 1
1182        fi
[103bc82]1183        echoAndLog "${FUNCNAME}(): config file created and linked, restarting apache daemon"
1184        service=$APACHESERV
1185        $ENABLESERVICE; $STARTSERVICE
1186        return 0
[a01156a]1187}
1188
[8fc9552]1189
[5d6bf97]1190# Crear documentación Doxygen para la consola web.
1191function makeDoxygenFiles()
1192{
1193        echoAndLog "${FUNCNAME}(): Making Doxygen web files..."
1194        $WORKDIR/opengnsys/installer/ogGenerateDoc.sh \
1195                        $WORKDIR/opengnsys/client/engine $INSTALL_TARGET/www
1196        if [ ! -d "$INSTALL_TARGET/www/html" ]; then
1197                errorAndLog "${FUNCNAME}(): unable to create Doxygen web files."
[ead38fb]1198                return 1
[5d6bf97]1199        fi
1200        mv "$INSTALL_TARGET/www/html" "$INSTALL_TARGET/www/api"
1201        echoAndLog "${FUNCNAME}(): Doxygen web files created successfully."
1202}
1203
1204
[a01156a]1205# Crea la estructura base de la instalación de opengnsys
[eb9424f]1206function createDirs()
[a01156a]1207{
1208        if [ $# -ne 1 ]; then
[dce072b]1209                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[a01156a]1210                exit 1
1211        fi
1212
[eb9424f]1213        local path_opengnsys_base="$1"
[a01156a]1214
[eb9424f]1215        # Crear estructura de directorios.
[dce072b]1216        echoAndLog "${FUNCNAME}(): creating directory paths in $path_opengnsys_base"
[a01156a]1217        mkdir -p $path_opengnsys_base
1218        mkdir -p $path_opengnsys_base/bin
[d47ec6c]1219        mkdir -p $path_opengnsys_base/client/{cache,images,log}
[49c6891]1220        mkdir -p $path_opengnsys_base/doc
[5c33840]1221        mkdir -p $path_opengnsys_base/etc
[a01156a]1222        mkdir -p $path_opengnsys_base/lib
[1cc5697]1223        mkdir -p $path_opengnsys_base/log/clients
[eb9424f]1224        ln -fs $path_opengnsys_base/log /var/log/opengnsys
[7586ca3]1225        mkdir -p $path_opengnsys_base/sbin
[a01156a]1226        mkdir -p $path_opengnsys_base/www
[d7ece95]1227        mkdir -p $path_opengnsys_base/images/groups
[87c7b02]1228        mkdir -p $TFTPCFGDIR
[63fd1ba]1229        ln -fs $TFTPCFGDIR $path_opengnsys_base/tftpboot
[c30c33e]1230        mkdir -p $path_opengnsys_base/tftpboot/{menu.lst,grub}
[a01156a]1231        if [ $? -ne 0 ]; then
[dce072b]1232                errorAndLog "${FUNCNAME}(): error while creating dirs. Do you have write permissions?"
[a01156a]1233                return 1
1234        fi
1235
[eb9424f]1236        # Crear usuario ficticio.
1237        if id -u $OPENGNSYS_CLIENT_USER &>/dev/null; then
1238                echoAndLog "${FUNCNAME}(): user \"$OPENGNSYS_CLIENT_USER\" is already created"
1239        else
[5f21d34]1240                echoAndLog "${FUNCNAME}(): creating OpenGnsys user"
[eb9424f]1241                useradd $OPENGNSYS_CLIENT_USER 2>/dev/null
1242                if [ $? -ne 0 ]; then
[5f21d34]1243                        errorAndLog "${FUNCNAME}(): error creating OpenGnsys user"
[eb9424f]1244                        return 1
1245                fi
1246        fi
1247
[7669bca]1248        # Mover el fichero de registro de instalación al directorio de logs.
[acfb07d]1249        echoAndLog "${FUNCNAME}(): moving installation log file"
1250        mv $LOG_FILE $OGLOGFILE && LOG_FILE=$OGLOGFILE
[7669bca]1251        chmod 600 $LOG_FILE
[acfb07d]1252
[dce072b]1253        echoAndLog "${FUNCNAME}(): directory paths created"
[a01156a]1254        return 0
1255}
1256
[463a1d49]1257# Copia ficheros de configuración y ejecutables genéricos del servidor.
[73a1bd6]1258function copyServerFiles ()
[e0edc14]1259{
[463a1d49]1260        if [ $# -ne 1 ]; then
[879689f]1261                errorAndLog "${FUNCNAME}(): invalid number of parameters"
[463a1d49]1262                exit 1
1263        fi
1264
[7caf5a7c]1265        local path_opengnsys_base="$1"
[463a1d49]1266
[a43e90d]1267        # Lista de ficheros y directorios origen y de directorios destino.
[cfad47b]1268        local SOURCES=( server/tftpboot \
[98dedfc]1269                        /usr/lib/shim/shimx64.efi.signed \
[c30c33e]1270                        /usr/lib/grub/x86_64-efi-signed/grubnetx64.efi.signed \
[7caf5a7c]1271                        server/bin \
1272                        repoman/bin \
[3e7d77b]1273                        server/lib \
[42a0e41]1274                        admin/Sources/Services/ogAdmServerAux
1275                        admin/Sources/Services/ogAdmRepoAux
[7caf5a7c]1276                        installer/opengnsys_uninstall.sh \
1277                        installer/opengnsys_update.sh \
[6777e3e]1278                        installer/opengnsys_export.sh \
1279                        installer/opengnsys_import.sh \
[7caf5a7c]1280                        doc )
[cfad47b]1281        local TARGETS=( tftpboot \
[c30c33e]1282                        tftpboot \
[98dedfc]1283                        tftpboot/grubx64.efi \
[7caf5a7c]1284                        bin \
1285                        bin \
[3e7d77b]1286                        lib \
[42a0e41]1287                        sbin \
1288                        sbin \
[7caf5a7c]1289                        lib \
1290                        lib \
[6777e3e]1291                        lib \
1292                        lib \
[7caf5a7c]1293                        doc )
[463a1d49]1294
1295        if [ ${#SOURCES[@]} != ${#TARGETS[@]} ]; then
[879689f]1296                errorAndLog "${FUNCNAME}(): inconsistent number of array items"
[463a1d49]1297                exit 1
1298        fi
1299
[a43e90d]1300        # Copiar ficheros.
[879689f]1301        echoAndLog "${FUNCNAME}(): copying files to server directories"
[f2bb433]1302
[8457092]1303        pushd $WORKDIR/opengnsys
[463a1d49]1304        local i
1305        for (( i = 0; i < ${#SOURCES[@]}; i++ )); do
1306                if [ -f "${SOURCES[$i]}" ]; then
[879689f]1307                        echoAndLog "Copying ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
[b5aae72]1308                        cp -a "${SOURCES[$i]}" "${path_opengnsys_base}/${TARGETS[$i]}"
[8457092]1309                elif [ -d "${SOURCES[$i]}" ]; then
[879689f]1310                        echoAndLog "Copying content of ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
[8457092]1311                        cp -a "${SOURCES[$i]}"/* "${path_opengnsys_base}/${TARGETS[$i]}"
[98dedfc]1312                else
[346eaee]1313                        warningAndLog "Unable to copy ${SOURCES[$i]} to $path_opengnsys_base/${TARGETS[$i]}"
[463a1d49]1314                fi
1315        done
[a43e90d]1316
[7586ca3]1317        popd
[892606b9]1318}
1319
[7586ca3]1320####################################################################
[5eb61a6]1321### Funciones de compilación de código fuente de servicios
[7586ca3]1322####################################################################
1323
[5f21d34]1324# Compilar los servicios de OpenGnsys
[7586ca3]1325function servicesCompilation ()
1326{
[13a01a7]1327        local hayErrores=0
[0795938]1328
[5f21d34]1329        # Compilar OpenGnsys Server
1330        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Admin Server"
[7b61735]1331        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer
[d168a46]1332        make && mv ogAdmServer $INSTALL_TARGET/sbin
[13a01a7]1333        if [ $? -ne 0 ]; then
[5f21d34]1334                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Admin Server"
[13a01a7]1335                hayErrores=1
1336        fi
[7586ca3]1337        popd
[5f21d34]1338        # Compilar OpenGnsys Agent
1339        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Agent"
[7b61735]1340        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent
[d168a46]1341        make && mv ogAdmAgent $INSTALL_TARGET/sbin
[4984660]1342        if [ $? -ne 0 ]; then
[5f21d34]1343                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Agent"
[4984660]1344                hayErrores=1
1345        fi
1346        popd   
[5f21d34]1347        # Compilar OpenGnsys Client
1348        echoAndLog "${FUNCNAME}(): Compiling OpenGnsys Admin Client"
[7b61735]1349        pushd $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient
[2338c95f]1350        make && mv ogAdmClient ../../../../client/shared/bin
[13a01a7]1351        if [ $? -ne 0 ]; then
[5f21d34]1352                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Admin Client"
[13a01a7]1353                hayErrores=1
1354        fi
[318efac]1355        popd
[13a01a7]1356
1357        return $hayErrores
[b6906f7]1358}
1359
[7b61735]1360####################################################################
1361### Funciones de copia de la Interface de administración
1362####################################################################
1363
1364# Copiar carpeta de Interface
[c1e00e4]1365function copyInterfaceAdm ()
[7b61735]1366{
1367        local hayErrores=0
1368       
[fbd9bcc]1369        # Crear carpeta y copiar Interface
[7b61735]1370        echoAndLog "${FUNCNAME}(): Copying Administration Interface Folder"
[fbd9bcc]1371        cp -ar $WORKDIR/opengnsys/admin/Interface $INSTALL_TARGET/client/interfaceAdm
[7b61735]1372        if [ $? -ne 0 ]; then
1373                echoAndLog "${FUNCNAME}(): error while copying Administration Interface Folder"
1374                hayErrores=1
1375        fi
1376
1377        return $hayErrores
1378}
[b6906f7]1379
[5050850]1380
[892606b9]1381####################################################################
1382### Funciones instalacion cliente opengnsys
1383####################################################################
1384
[73a1bd6]1385function copyClientFiles()
[7586ca3]1386{
[d168a46]1387        local errstatus=0
[a555f49]1388
[5f21d34]1389        echoAndLog "${FUNCNAME}(): Copying OpenGnsys Client files."
[73a1bd6]1390        cp -a $WORKDIR/opengnsys/client/shared/* $INSTALL_TARGET/client
[d47d38d]1391        if [ $? -ne 0 ]; then
[9ef8920]1392                errorAndLog "${FUNCNAME}(): error while copying client estructure"
[d168a46]1393                errstatus=1
[9ef8920]1394        fi
1395       
[5f21d34]1396        echoAndLog "${FUNCNAME}(): Copying OpenGnsys Cloning Engine files."
[d47d38d]1397        mkdir -p $INSTALL_TARGET/client/lib/engine/bin
[73a1bd6]1398        cp -a $WORKDIR/opengnsys/client/engine/*.lib* $INSTALL_TARGET/client/lib/engine/bin
[a555f49]1399        if [ $? -ne 0 ]; then
1400                errorAndLog "${FUNCNAME}(): error while copying engine files"
[d168a46]1401                errstatus=1
[a555f49]1402        fi
[9ef8920]1403       
[d168a46]1404        if [ $errstatus -eq 0 ]; then
[9ef8920]1405                echoAndLog "${FUNCNAME}(): client copy files success."
1406        else
1407                errorAndLog "${FUNCNAME}(): client copy files with errors"
1408        fi
1409
[d168a46]1410        return $errstatus
[463a1d49]1411}
1412
1413
[5050850]1414# Crear certificados para la firma de cargadores de arranque.
1415function createCerts ()
1416{
1417        local SSLCFGDIR=$INSTALL_TARGET/client/etc/ssl
1418        echoAndLog "${FUNCNAME}(): creating certificate files"
1419        mkdir -p $SSLCFGDIR/{certs,private}
1420        openssl req -new -x509 -newkey rsa:2048 -keyout $SSLCFGDIR/private/opengnsys.key -out $SSLCFGDIR/certs/opengnsys.crt -nodes -days 3650 -subj "/CN=OpenGnsys/"
1421        openssl x509 -in $SSLCFGDIR/certs/opengnsys.crt -out $SSLCFGDIR/certs/opengnsys.cer -outform DER
1422        echoAndLog "${FUNCNAME}(): certificate successfully created"
1423}
1424
1425
[5f21d34]1426# Crear cliente OpenGnsys.
[5ad5dcc]1427function clientCreate()
[813f617]1428{
[6019b12]1429        if [ $# -ne 1 ]; then
1430                errorAndLog "${FUNCNAME}(): invalid number of parameters"
1431                exit 1
1432        fi
1433
1434        local FILENAME="$1"
[0b85cc93]1435        local TARGETFILE=$INSTALL_TARGET/lib/$FILENAME
[d168a46]1436 
[79c26a8]1437        # Descargar cliente, si es necesario.
1438        if [ -s $PROGRAMDIR/$FILENAME ]; then
1439                echoAndLog "${FUNCNAME}(): Moving $PROGRAMDIR/$FILENAME file to $(dirname $TARGETFILE)"
1440                mv $PROGRAMDIR/$FILENAME $TARGETFILE
1441        else
[ec045b1]1442                echoAndLog "${FUNCNAME}(): Downloading $FILENAME"
[6019b12]1443                oglivecli download $FILENAME
[79c26a8]1444        fi
[0b85cc93]1445        if [ ! -s $TARGETFILE ]; then
[ec045b1]1446                errorAndLog "${FUNCNAME}(): Error loading $FILENAME"
[813f617]1447                return 1
1448        fi
[1893b9d]1449
[79c26a8]1450        # Montar imagen, copiar cliente ogclient y desmontar.
[0496417]1451        echoAndLog "${FUNCNAME}(): Installing ogLive Client"
[6ef01d9]1452        echo -ne "$OPENGNSYS_CLIENT_PASSWD\n$OPENGNSYS_CLIENT_PASSWD\n" | \
[6019b12]1453                        oglivecli install $FILENAME
[6ef01d9]1454
[813f617]1455        echoAndLog "${FUNCNAME}(): Client generation success"
1456}
1457
1458
[5f21d34]1459# Configuración básica de servicios de OpenGnsys
[cc7eab7]1460function openGnsysConfigure()
1461{
[d168a46]1462        local i=0
1463        local dev=""
[7d4ce64]1464        local CONSOLEURL
[d168a46]1465
[9ee62ad]1466        echoAndLog "${FUNCNAME}(): Copying init files."
[42a0e41]1467        cp -a $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys
1468        cp -a $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.default /etc/default/opengnsys
[b8969db]1469        # Deshabilitar servicios de BitTorrent si no están instalados.
1470        if [ ! -e /usr/bin/bttrack ]; then
[fdab5d0]1471                sed -i 's/RUN_BTTRACKER="yes"/RUN_BTTRACKER="no"/; s/RUN_BTSEEDER="yes"/RUN_BTSEEDER="no"/' \
[b8969db]1472                        /etc/default/opengnsys
1473        fi
[9ee62ad]1474        echoAndLog "${FUNCNAME}(): Creating cron files."
[57cf15b]1475        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/opengnsys.cron ] && $INSTALL_TARGET/bin/opengnsys.cron" > /etc/cron.d/opengnsys
[9ee62ad]1476        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-creator ] && $INSTALL_TARGET/bin/torrent-creator" > /etc/cron.d/torrentcreator
[8fc9552]1477        echo "5 * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-tracker ] && $INSTALL_TARGET/bin/torrent-tracker" > /etc/cron.d/torrenttracker
[dc762088]1478        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/deletepreimage ] && $INSTALL_TARGET/bin/deletepreimage" > /etc/cron.d/imagedelete
[0645906]1479        echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/ogagentqueue.cron ] && $INSTALL_TARGET/bin/ogagentqueue.cron" > /etc/cron.d/ogagentqueue
[d168a46]1480
[1be256f]1481        echoAndLog "${FUNCNAME}(): Creating logrotate configuration files."
[700299b]1482        sed -e "s/OPENGNSYSDIR/${INSTALL_TARGET//\//\\/}/g" \
[1be256f]1483                $WORKDIR/opengnsys/server/etc/logrotate.tmpl > /etc/logrotate.d/opengnsysServer
1484
1485        sed -e "s/OPENGNSYSDIR/${INSTALL_TARGET//\//\\/}/g" \
1486                $WORKDIR/opengnsys/repoman/etc/logrotate.tmpl > /etc/logrotate.d/opengnsysRepo
[700299b]1487
[5f21d34]1488        echoAndLog "${FUNCNAME}(): Creating OpenGnsys config files."
[d168a46]1489        for dev in ${DEVICE[*]}; do
1490                if [ -n "${SERVERIP[i]}" ]; then
1491                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1492                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
1493                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
1494                            -e "s/DATABASE/$OPENGNSYS_DATABASE/g" \
[8948748]1495                            -e "s/REPOKEY/$OPENGNSYS_REPOKEY/g" \
[d168a46]1496                                $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer/ogAdmServer.cfg > $INSTALL_TARGET/etc/ogAdmServer-$dev.cfg
1497                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
[f9b5714]1498                            -e "s/REPOKEY/$OPENGNSYS_REPOKEY/g" \
[b351d8a]1499                                $WORKDIR/opengnsys/repoman/etc/ogAdmRepo.cfg.tmpl > $INSTALL_TARGET/etc/ogAdmRepo-$dev.cfg
[d168a46]1500                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1501                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
1502                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
1503                            -e "s/DATABASE/$OPENGNSYS_DATABASE/g" \
1504                                $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent/ogAdmAgent.cfg > $INSTALL_TARGET/etc/ogAdmAgent-$dev.cfg
[1a2fa9d8]1505                        CONSOLEURL="https://${SERVERIP[i]}/opengnsys"
[d168a46]1506                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
1507                            -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
1508                            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
1509                            -e "s/DATABASE/$OPENGNSYS_DATABASE/g" \
[b22305e]1510                            -e "s/OPENGNSYSURL/${CONSOLEURL//\//\\/}/g" \
[d168a46]1511                                $INSTALL_TARGET/www/controlacceso.php > $INSTALL_TARGET/www/controlacceso-$dev.php
1512                        sed -e "s/SERVERIP/${SERVERIP[i]}/g" \
[d7f8305]1513                            -e "s/OPENGNSYSURL/${CONSOLEURL//\//\\/}/g" \
[d168a46]1514                                $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient/ogAdmClient.cfg > $INSTALL_TARGET/client/etc/ogAdmClient-$dev.cfg
[7d4ce64]1515                        if [ "$dev" == "$DEFAULTDEV" ]; then
[1a2fa9d8]1516                                OPENGNSYS_CONSOLEURL="$CONSOLEURL"
[7d4ce64]1517                        fi
[d168a46]1518                fi
1519                let i++
1520        done
1521        ln -f $INSTALL_TARGET/etc/ogAdmServer-$DEFAULTDEV.cfg $INSTALL_TARGET/etc/ogAdmServer.cfg
1522        ln -f $INSTALL_TARGET/etc/ogAdmRepo-$DEFAULTDEV.cfg $INSTALL_TARGET/etc/ogAdmRepo.cfg
1523        ln -f $INSTALL_TARGET/etc/ogAdmAgent-$DEFAULTDEV.cfg $INSTALL_TARGET/etc/ogAdmAgent.cfg
1524        ln -f $INSTALL_TARGET/client/etc/ogAdmClient-$DEFAULTDEV.cfg $INSTALL_TARGET/client/etc/ogAdmClient.cfg
1525        ln -f $INSTALL_TARGET/www/controlacceso-$DEFAULTDEV.php $INSTALL_TARGET/www/controlacceso.php
[1f7b2d0]1526
[a3855dc]1527        # Configuración del motor de clonación.
1528        # - Zona horaria del servidor.
1529        TZ=$(timedatectl status|awk -F"[:()]" '/Time.*zone/ {print $2}')
1530        cat << EOT >> $INSTALL_TARGET/client/etc/engine.cfg
1531# OpenGnsys Server timezone.
1532TZ="${TZ// /}"
1533EOT
1534
[1f7b2d0]1535        # Revisar permisos generales.
1536        if [ -x $INSTALL_TARGET/bin/checkperms ]; then
1537                echoAndLog "${FUNCNAME}(): Checking permissions."
[6019b12]1538                OPENGNSYS_DIR="$INSTALL_TARGET" OPENGNSYS_USER="$OPENGNSYS_CLIENT_USER" APACHE_USER="$APACHE_RUN_USER" APACHE_GROUP="$APACHE_RUN_GROUP" checkperms
[1f7b2d0]1539        fi
1540
[4e19f13]1541        # Evitar inicio de duplicado en Ubuntu 14.04 (Upstart y SysV Init).
[c7ade22]1542        if [ -f /etc/init/${MYSQLSERV}.conf -a -n "$(which initctl 2>/dev/null)" ]; then
[4e19f13]1543                service=$MYSQLSERV
1544                $DISABLESERVICE
1545        fi
1546
[5f21d34]1547        echoAndLog "${FUNCNAME}(): Starting OpenGnsys services."
[53fba30]1548        service="opengnsys"
1549        $ENABLESERVICE; $STARTSERVICE
[cc7eab7]1550}
1551
[b6906f7]1552
[a01156a]1553#####################################################################
[180a07dd]1554#######  Función de resumen informativo de la instalación
1555#####################################################################
1556
[813f617]1557function installationSummary()
1558{
[832e27b]1559        local VERSIONFILE REVISION
1560
[eb9424f]1561        # Crear fichero de versión y revisión, si no existe.
[3bbaf79]1562        VERSIONFILE="$INSTALL_TARGET/doc/VERSION.json"
1563        [ -f $VERSIONFILE ] || echo '{ "project": "OpenGnsys" }' >$VERSIONFILE
1564        # Incluir datos de revisión, si se está instalando desde el repositorio
[130bdbf]1565        # de código o si no está incluida en el fichero de versión.
[3bbaf79]1566        if [ $REMOTE -eq 1 ] || [ -z "$(jq -r '.release' $VERSIONFILE)" ]; then
[832e27b]1567                # Revisión: rAñoMesDía.Gitcommit (8 caracteres de fecha y 7 primeros de commit).
[b411a0f]1568                REVISION=$(curl -s "$API_URL" | jq '"r" + (.commit.commit.committer.date | split("-") | join("")[:8]) + "." + (.commit.sha[:7])')
[3bbaf79]1569                jq ".release=$REVISION" $VERSIONFILE | sponge $VERSIONFILE
[130bdbf]1570        fi
[3bbaf79]1571        VERSION="$(jq -r '[.project, .version, .codename, .release] | join(" ")' $VERSIONFILE 2>/dev/null)"
[eb9424f]1572
1573        # Mostrar información.
[180a07dd]1574        echo
[5f21d34]1575        echoAndLog "OpenGnsys Installation Summary"
[180a07dd]1576        echo       "=============================="
[3bbaf79]1577        echoAndLog "Project version:                  $VERSION"
[49c6891]1578        echoAndLog "Installation directory:           $INSTALL_TARGET"
[acfb07d]1579        echoAndLog "Installation log file:            $LOG_FILE"
[49c6891]1580        echoAndLog "Repository directory:             $INSTALL_TARGET/images"
[d168a46]1581        echoAndLog "DHCP configuration directory:     $DHCPCFGDIR"
[87c7b02]1582        echoAndLog "TFTP configuration directory:     $TFTPCFGDIR"
[6019b12]1583        echoAndLog "Installed ogLive client(s):       $(oglivecli list | awk '{print $2}')"
[87c7b02]1584        echoAndLog "Samba configuration directory:    $SAMBACFGDIR"
[49c6891]1585        echoAndLog "Web Console URL:                  $OPENGNSYS_CONSOLEURL"
[6bd2e1e]1586        echoAndLog "Web Console access data:          entered by the user"
[b8969db]1587        if grep -q "^RUN_BTTRACK.*no" /etc/default/opengnsys; then
1588                echoAndLog "BitTorrent service is disabled."
1589        fi
[180a07dd]1590        echo
1591        echoAndLog "Post-Installation Instructions:"
1592        echo       "==============================="
[6bd2e1e]1593        echoAndLog "You can improve server security by configuring firewall and SELinux,"
1594        echoAndLog "   running \"$INSTALL_TARGET/lib/security-config\" script as root."
[4faafcd]1595        echoAndLog "It's strongly recommended to synchronize this server with an NTP server."
[180a07dd]1596        echoAndLog "Review or edit all configuration files."
[c5ce04c]1597        echoAndLog "Insert DHCP configuration data and restart service."
[af5efd6]1598        echoAndLog "Optional: Log-in as Web Console admin user."
1599        echoAndLog " - Review default Organization data and assign access to users."
[180a07dd]1600        echoAndLog "Log-in as Web Console organization user."
[5f21d34]1601        echoAndLog " - Insert OpenGnsys data (labs, computers, menus, etc)."
[180a07dd]1602echo
1603}
1604
1605
1606
1607#####################################################################
[5f21d34]1608####### Proceso de instalación de OpenGnsys
[a01156a]1609#####################################################################
1610
[8ca0cc9]1611# Sólo ejecutable por usuario root
1612if [ "$(whoami)" != 'root' ]; then
1613        echo "ERROR: this program must run under root privileges!!"
1614        exit 1
1615fi
1616
1617globalSetup
[5f21d34]1618echoAndLog "OpenGnsys installation begins at $(date)"
[8ca0cc9]1619# Introducir datos de configuración y establecer variables globales.
1620userData
1621
1622mkdir -p $WORKDIR
[6090a2d]1623pushd $WORKDIR
[cc7eab7]1624
[af5efd6]1625# Detectar datos iniciales de auto-configuración del instalador.
[d168a46]1626autoConfigure
1627
1628# Detectar parámetros de red y comprobar si hay conexión.
1629getNetworkSettings
1630if [ $? -ne 0 ]; then
1631        errorAndLog "Error reading default network settings."
1632        exit 1
1633fi
[07c3a59]1634checkNetworkConnection
1635if [ $? -ne 0 ]; then
1636        errorAndLog "Error connecting to server. Causes:"
1637        errorAndLog " - Network is unreachable, review devices parameters."
1638        errorAndLog " - You are inside a private network, configure the proxy service."
1639        errorAndLog " - Server is temporally down, try agian later."
1640        exit 1
1641fi
[7586ca3]1642
[5f21d34]1643# Detener servicios de OpenGnsys, si están activos previamente.
[e0edc14]1644[ -f /etc/init.d/opengnsys ] && /etc/init.d/opengnsys stop
1645
[318efac]1646# Actualizar repositorios
[83518d5]1647updatePackageList
[318efac]1648
[b6906f7]1649# Instalación de dependencias (paquetes de sistema operativo).
[a01156a]1650declare -a notinstalled
1651checkDependencies DEPENDENCIES notinstalled
1652if [ $? -ne 0 ]; then
1653        installDependencies notinstalled
1654        if [ $? -ne 0 ]; then
1655                echoAndLog "Error while installing some dependeces, please verify your server installation before continue"
1656                exit 1
1657        fi
1658fi
[109e8b2]1659if [ -n "$INSTALLEXTRADEPS" ]; then
1660        echoAndLog "Installing extra dependencies"
1661        for (( i=0; i<${#INSTALLEXTRADEPS[*]}; i++ )); do
1662                eval ${INSTALLEXTRADEPS[i]}
1663        done
1664fi     
[a01156a]1665
[ff6c349]1666# Detectar datos de auto-configuración después de instalar paquetes.
1667autoConfigurePost
1668
[5f21d34]1669# Arbol de directorios de OpenGnsys.
[eb9424f]1670createDirs ${INSTALL_TARGET}
[a01156a]1671if [ $? -ne 0 ]; then
1672        errorAndLog "Error while creating directory paths!"
1673        exit 1
1674fi
[b6906f7]1675
[1e7eaab]1676# Si es necesario, descarga el repositorio de código en directorio temporal
[884b6ce]1677if [ $REMOTE -eq 1 ]; then
1678        downloadCode $CODE_URL
[1e7eaab]1679        if [ $? -ne 0 ]; then
[884b6ce]1680                errorAndLog "Error while getting code from the repository"
[1e7eaab]1681                exit 1
1682        fi
1683else
1684        ln -fs "$(dirname $PROGRAMDIR)" opengnsys
[a01156a]1685fi
1686
[5f21d34]1687# Compilar código fuente de los servicios de OpenGnsys.
[b6906f7]1688servicesCompilation
[13a01a7]1689if [ $? -ne 0 ]; then
1690        errorAndLog "Error while compiling OpenGnsys services"
1691        exit 1
1692fi
[b6906f7]1693
[7b61735]1694# Copiar carpeta Interface entre administración y motor de clonación.
[c1e00e4]1695copyInterfaceAdm
[7b61735]1696if [ $? -ne 0 ]; then
[c1e00e4]1697        errorAndLog "Error while copying Administration Interface"
[7b61735]1698        exit 1
1699fi
1700
[e70925a]1701# Configuración de TFTP.
[318efac]1702tftpConfigure
[b6906f7]1703
[e70925a]1704# Configuración de Samba.
[8fc9552]1705smbConfigure
1706if [ $? -ne 0 ]; then
[c1e00e4]1707        errorAndLog "Error while configuring Samba server!"
[8fc9552]1708        exit 1
1709fi
1710
[e70925a]1711# Configuración de Rsync.
1712rsyncConfigure
1713
1714# Configuración ejemplo DHCP.
[b6906f7]1715dhcpConfigure
[a555f49]1716if [ $? -ne 0 ]; then
1717        errorAndLog "Error while copying your dhcp server files!"
1718        exit 1
1719fi
[b6906f7]1720
[5f21d34]1721# Copiar ficheros de servicios OpenGnsys Server.
[73a1bd6]1722copyServerFiles ${INSTALL_TARGET}
[463a1d49]1723if [ $? -ne 0 ]; then
1724        errorAndLog "Error while copying the server files!"
1725        exit 1
1726fi
[9815cac]1727INSTVERSION=$(jq -r '.version' $INSTALL_TARGET/doc/VERSION.json)
[463a1d49]1728
[5f21d34]1729# Instalar base de datos de OpenGnsys Admin.
[5cc52295]1730isInArray notinstalled "mysql-server" || isInArray notinstalled "mariadb-server"
[b6906f7]1731if [ $? -eq 0 ]; then
[094ac0d]1732        # Habilitar gestor de base de datos (MySQL, si falla, MariaDB).
1733        service=$MYSQLSERV
1734        $ENABLESERVICE
1735        if [ $? != 0 ]; then
1736                service=$MARIADBSERV
1737                $ENABLESERVICE
1738        fi
1739        # Activar gestor de base de datos.
[0f8100d]1740        $STARTSERVICE
[094ac0d]1741        # Asignar clave del usuario "root".
[09bf701]1742        mysqlSetRootPassword "${MYSQL_ROOT_PASSWORD}"
[b6906f7]1743else
[094ac0d]1744        # Si ya está instalado el gestor de bases de datos, obtener clave de "root",
[b6906f7]1745        mysqlGetRootPassword
1746fi
[463a1d49]1747
[09bf701]1748mysqlTestConnection "${MYSQL_ROOT_PASSWORD}"
[a01156a]1749if [ $? -ne 0 ]; then
1750        errorAndLog "Error while connection to mysql"
1751        exit 1
1752fi
[09bf701]1753mysqlDbExists ${OPENGNSYS_DATABASE}
[a01156a]1754if [ $? -ne 0 ]; then
[cc7eab7]1755        echoAndLog "Creating Web Console database"
[09bf701]1756        mysqlCreateDb ${OPENGNSYS_DATABASE}
[a01156a]1757        if [ $? -ne 0 ]; then
[cc7eab7]1758                errorAndLog "Error while creating Web Console database"
[a01156a]1759                exit 1
1760        fi
1761else
[cc7eab7]1762        echoAndLog "Web Console database exists, ommiting creation"
[a01156a]1763fi
1764
[09bf701]1765mysqlCheckUserExists ${OPENGNSYS_DB_USER}
[a01156a]1766if [ $? -ne 0 ]; then
1767        echoAndLog "Creating user in database"
[09bf701]1768        mysqlCreateAdminUserToDb ${OPENGNSYS_DATABASE} ${OPENGNSYS_DB_USER} "${OPENGNSYS_DB_PASSWD}"
[a01156a]1769        if [ $? -ne 0 ]; then
[cc7eab7]1770                errorAndLog "Error while creating database user"
[a01156a]1771                exit 1
1772        fi
1773
1774fi
1775
[09bf701]1776mysqlCheckDbIsEmpty ${OPENGNSYS_DATABASE}
[a01156a]1777if [ $? -eq 0 ]; then
1778        echoAndLog "Creating tables..."
[892606b9]1779        if [ -f $WORKDIR/$OPENGNSYS_DB_CREATION_FILE ]; then
[09bf701]1780                mysqlImportSqlFileToDb ${OPENGNSYS_DATABASE} $WORKDIR/$OPENGNSYS_DB_CREATION_FILE
[a01156a]1781        else
[892606b9]1782                errorAndLog "Unable to locate $WORKDIR/$OPENGNSYS_DB_CREATION_FILE!!"
[a01156a]1783                exit 1
1784        fi
[bc7dfe7]1785else
1786        # Si existe fichero ogBDAdmin-VersLocal-VersRepo.sql; aplicar cambios.
[9815cac]1787        REPOVERSION=$(jq -r '.version' $WORKDIR/opengnsys/doc/VERSION.json)
[295b4ab]1788        OPENGNSYS_DB_UPDATE_FILE="opengnsys/admin/Database/$OPENGNSYS_DATABASE-$INSTVERSION-$REPOVERSION.sql"
1789        if [ -f $WORKDIR/$OPENGNSYS_DB_UPDATE_FILE ]; then
[bc7dfe7]1790                echoAndLog "Updating tables from version $INSTVERSION to $REPOVERSION"
[09bf701]1791                mysqlImportSqlFileToDb ${OPENGNSYS_DATABASE} $WORKDIR/$OPENGNSYS_DB_UPDATE_FILE
[bc7dfe7]1792        else
1793                echoAndLog "Database unchanged."
1794        fi
[a01156a]1795fi
[09bf701]1796# Eliminar fichero temporal con credenciales de acceso a MySQL.
1797rm -f $TMPMYCNF
[a01156a]1798
[5f21d34]1799# Copiando páqinas web.
[7586ca3]1800installWebFiles
[ec045b1]1801# Descargar/descomprimir archivos descargables.
1802installDownloadableFiles
[5d6bf97]1803# Generar páqinas web de documentación de la API
1804makeDoxygenFiles
[a01156a]1805
[5f21d34]1806# Creando configuración de Apache.
[5fcf180]1807installWebConsoleApacheConf $INSTALL_TARGET $APACHECFGDIR
[a01156a]1808if [ $? -ne 0 ]; then
[5f21d34]1809        errorAndLog "Error configuring Apache for OpenGnsys Admin"
[a01156a]1810        exit 1
1811fi
1812
1813popd
[892606b9]1814
[9ef8920]1815# Crear la estructura de los accesos al servidor desde el cliente (shared)
[73a1bd6]1816copyClientFiles
[9ef8920]1817if [ $? -ne 0 ]; then
1818        errorAndLog "Error creating client structure"
1819fi
1820
[5050850]1821# Crear certificado para firmar cargadores
1822createCerts
1823
[5f21d34]1824# Crear la estructura del cliente de OpenGnsys.
[6019b12]1825for i in $OGLIVE; do
1826        if ! clientCreate "$i"; then
1827                errorAndLog "Error creating client $i"
1828                exit 1
1829        fi
1830done
[892606b9]1831
[5f21d34]1832# Configuración de servicios de OpenGnsys
[65245d1]1833openGnsysConfigure
1834
[180a07dd]1835# Mostrar sumario de la instalación e instrucciones de post-instalación.
1836installationSummary
1837
[077dd7c5]1838#rm -rf $WORKDIR
[5f21d34]1839echoAndLog "OpenGnsys installation finished at $(date)"
[05d2e03]1840exit 0
[2308fc7]1841
Note: See TracBrowser for help on using the repository browser.